Validator = require("validator").Validator;
validator = new Validator();

testCheck = validator.check();

Validator.prototype.error = function (msg) {
    this._errors || (this._errors=[])
    this._errors.push(msg);
    return this;
};

Validator.prototype.getErrors = function () {
    return this._errors;
};


function field(){
  return new DeferValidation([], "__root", []);
}

DeferValidation = function(queue, fnName, args){
  queue.push(this);
  this.fn = fnName;
  this.args = args;
  this.queue = queue;
};

function addDeferValidation(k){
  if(!testCheck.hasOwnProperty(k)){
    DeferValidation.prototype[k] = function(){
      var args = Array.prototype.slice.apply(arguments);
      var next = new DeferValidation( this.queue, k, args);
      return next;
    };
  }
}

for(var k in testCheck ){ 
  addDeferValidation(k);
}

DeferValidation.prototype.check = function(target){
  v = new Validator();
  var result = v.check(target, this.queue[0].msg);
  var current;

  for (var i=1; i < this.queue.length; i++) {
    current = this.queue[i];    
    result = result[current.fn].apply(result, current.args);
  }

  var errors = v.getErrors();
  if(errors.length) return errors;
};


function schema(obj){
  this.obj = obj;
}

schema.prototype.check = function(data){
  var result = {}, errors, cnt = 0;
  for(var prop in this.obj){
    errors = this.obj[prop].check(data[prop]);
    if(errors){
      cnt = cnt + 1;
      result[prop] = errors;
    }
  }
  if(cnt) return result;
};

module.exports.check = field;
module.exports.schema = schema;

