var check = require("./index.js").check;
var schema = require("./index.js").schema;

onlyAs = check().len(2, 8).is(/^a*$/).in(["aaa", "aaaa"]);

errors = onlyAs.check("1");
console.log("one char:", errors);

errors = onlyAs.check("az");
console.log("bad char:", errors);

errors = onlyAs.check("aaaa");
console.log("is good:", errors);


var userValidator = new schema({
  email: check().isEmail().len(4, 64),
  password: check().len(4, 80).notIn(["password", "love", "12345"])
});

var results = userValidator.check({
  email:"ab@c",
  password: "love"
});

console.log(results);

validResults = userValidator.check({
  email:"aaron.blohowiak@gmail.com",
  password: "w00t!!!"
});

console.log(validResults);

registrationValidator = new schema({
  subdomain: check().is(/[a-zA-Z][a-zA-Z0-9]*/),
  user: userValidator
})

var regResult = registrationValidator.check({
  subdomain: "w3",
  user: {
    email: "aaron.blohowiak@gmail.com",
    password: "w00t!!!"
  }
})

console.log(regResult);

mixedResult = registrationValidator.check({
  subdomain: "w3",
  user: {
    email: "@gmail.com",
    password: "w00t!!!"
  }
})

console.log(mixedResult);


var badRegistration = registrationValidator.check({
  subdomain: "3",
  user: {
    email: "abc",
    password: "love"
  }
})

console.log(badRegistration);
